//+------------------------------------------------------------------+
//|                                               Volume_Counter.mq4 |
//|                                                         Zen_Leow |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Zen_Leow"
#property link      ""

#property indicator_chart_window
extern int Count_Bars = 20;
extern int Top_Offset = 10; 
extern int Right_Offset  = 30;
extern string Corner_Index_Desc = "0:TopLeft | 1:TopRight | 2:BottomLeft | 3:BottomRight";
extern int Corner_Index = 3;
extern color Title_Text_Color = Blue;
extern color UP_Text_Color = Green;
extern color DOWN_Text_Color = Red;

int Font_Size = 10;
int subsequent_offset = 15;
double Up_Volume = 0;
double Down_Volume = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   Up_Volume = 0;
   Down_Volume = 0;
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
   ObjectsDeleteAll(0,OBJ_LABEL); 
//----
   return(0);
}

void CalculateVolume()
{
   Up_Volume = 0;
   Down_Volume = 0;
   
   for (int i=0; i<Count_Bars; i++)
   {
      if (Close[i] > Open[i])
      {
         Up_Volume = Up_Volume + Volume[i];
      }
      if (Close[i] < Open[i])
      {
         Down_Volume = Down_Volume + Volume[i];
      }
   }
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{  
   CalculateVolume();

   ObjectCreate("Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Title","Number of Bars Counted: "+Count_Bars, Font_Size, "Arial",  Title_Text_Color);
   ObjectSet("Title", OBJPROP_CORNER, Corner_Index);
   ObjectSet("Title", OBJPROP_XDISTANCE, Right_Offset);
   ObjectSet("Title", OBJPROP_YDISTANCE, Top_Offset);
   
   ObjectCreate("UpLabel", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("UpLabel","UP Bars: "+DoubleToStr(Up_Volume,0), Font_Size, "Arial",  UP_Text_Color);
   ObjectSet("UpLabel", OBJPROP_CORNER, Corner_Index);
   ObjectSet("UpLabel", OBJPROP_XDISTANCE, Right_Offset);
   ObjectSet("UpLabel", OBJPROP_YDISTANCE, Top_Offset+subsequent_offset);
      
   ObjectCreate("DownLabel", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("DownLabel","DOWN Bars: "+DoubleToStr(Down_Volume,0), Font_Size, "Arial",  DOWN_Text_Color);
   ObjectSet("DownLabel", OBJPROP_CORNER, Corner_Index);
   ObjectSet("DownLabel", OBJPROP_XDISTANCE, Right_Offset);
   ObjectSet("DownLabel", OBJPROP_YDISTANCE, Top_Offset+subsequent_offset*2);
 //----
   return(0);
}
//+------------------------------------------------------------------+